Subject: Re: [RFC net-next 1/5] devlink: Add unique identifier to devlink port function

From: Simon Horman <[email-masked]>
Date: Mon, 28 Apr 2025 13:33:29 +0100

On Wed, Apr 23, 2025 at 04:50:38PM +0300, Moshe Shemesh wrote:
> From: Avihai Horon <[email-masked]>
> 
> A function unique identifier (UID) is a vendor defined string of
> arbitrary length that universally identifies a function. The function
> UID can be reported via devlink dev info.
> 
> Add UID attribute to devlink port function that reports the UID of the
> function that pertains to the devlink port.
> 
> This can be used to unambiguously map between a function and the devlink
> port that manages it, and vice versa.
> 
> Example output:
> 
> $ devlink port show pci/0000:03:00.0/327680 -jp
> {
>     "port": {
>         "pci/0000:03:00.0/327680": {
>             "type": "eth",
>             "netdev": "pf0hpf",
>             "flavour": "pcipf",
>             "controller": 1,
>             "pfnum": 0,
>             "external": true,
>             "splittable": false,
>             "function": {
>                 "hw_addr": "5c:25:73:37:70:5a",
>                 "roce": "enable",
>                 "max_io_eqs": 120,
>                 "uid": "C6A76AD20605BE026D23C14E70B90704F4A5F5B3F304D83B37000732BF861D48MLNXS0D0F0"
>             }
>         }
>     }
> }
> 
> Signed-off-by: Avihai Horon <[email-masked]>
> ---
>  Documentation/netlink/specs/devlink.yaml      |  3 ++
>  .../networking/devlink/devlink-port.rst       | 12 +++++++
>  include/net/devlink.h                         |  8 +++++
>  include/uapi/linux/devlink.h                  |  1 +
>  net/devlink/port.c                            | 32 +++++++++++++++++++
>  5 files changed, 56 insertions(+)
> 
> diff --git a/Documentation/netlink/specs/devlink.yaml b/Documentation/netlink/specs/devlink.yaml
> index bd9726269b4f..f4dade0e3c70 100644
> --- a/Documentation/netlink/specs/devlink.yaml
> +++ b/Documentation/netlink/specs/devlink.yaml
> @@ -894,6 +894,9 @@ attribute-sets:
>          type: bitfield32
>          enum: port-fn-attr-cap
>          enum-as-flags: True
> +      -
> +       name: uid
> +       type: string
>  
>    -
>      name: dl-dpipe-tables

Hi Avihai,

With this patch, after running tools/net/ynl/ynl-regen.sh -f, I see the
following when I run git diff. So I think this patch needs these changes
too.

diff --git a/net/devlink/netlink_gen.c b/net/devlink/netlink_gen.c
index f9786d51f..1dc90bde8 100644
--- a/net/devlink/netlink_gen.c
+++ b/net/devlink/netlink_gen.c
@@ -11,11 +11,12 @@
 #include <uapi/linux/devlink.h>

 /* Common nested types */
-const struct nla_policy devlink_dl_port_function_nl_policy[DEVLINK_PORT_FN_ATTR_CAPS + 1] = {
+const struct nla_policy devlink_dl_port_function_nl_policy[DEVLINK_PORT_FN_ATTR_UID + 1] = {
 	[DEVLINK_PORT_FUNCTION_ATTR_HW_ADDR] = { .type = NLA_BINARY, },
 	[DEVLINK_PORT_FN_ATTR_STATE] = NLA_POLICY_MAX(NLA_U8, 1),
 	[DEVLINK_PORT_FN_ATTR_OPSTATE] = NLA_POLICY_MAX(NLA_U8, 1),
 	[DEVLINK_PORT_FN_ATTR_CAPS] = NLA_POLICY_BITFIELD32(15),
+	[DEVLINK_PORT_FN_ATTR_UID] = { .type = NLA_NUL_STRING, },
 };

 const struct nla_policy devlink_dl_selftest_id_nl_policy[DEVLINK_ATTR_SELFTEST_ID_FLASH + 1] = {
diff --git a/net/devlink/netlink_gen.h b/net/devlink/netlink_gen.h
index 8f2bd50dd..3a12c18c6 100644
--- a/net/devlink/netlink_gen.h
+++ b/net/devlink/netlink_gen.h
@@ -12,7 +12,7 @@
 #include <uapi/linux/devlink.h>

 /* Common nested types */
-extern const struct nla_policy devlink_dl_port_function_nl_policy[DEVLINK_PORT_FN_ATTR_CAPS + 1];
+extern const struct nla_policy devlink_dl_port_function_nl_policy[DEVLINK_PORT_FN_ATTR_UID + 1];
 extern const struct nla_policy devlink_dl_selftest_id_nl_policy[DEVLINK_ATTR_SELFTEST_ID_FLASH + 1];

 /* Ops table for devlink */

...